
const OPERATION06010_GRID_ID = '#ITP_OPERATION06010_jqGrid';
const OPERATION06010_GRID_LIST = '#ITP_OPERATION06010_jqGrid_list';
const OPERATION06010_GRID_PAGER = '#ITP_OPERATION06010_jqGridPager';
const OPERATION06010_GRID_EMPTY = '#ITP_OPERATION06010_jqGridEmpty';

let ITP_FORM_OPERATION06010_DETAIL_IS_WRITING = false;

let INTERFACE_SAVE_INTERFACE = '/api/interface/save-interface';
let INTERFACE_DETAIL_GRID_LIST = '/api/interface/detail-grid-list';
let INTERFACE_INFO_INTERFACE = '/api/interface/info-interface';
let INTERFACE_REMOVE_INTERFACE = '/api/interface/remove-interface';

require(['config'], function() {
	require([
		'jquery',
		'jquery.bootstrap.fileUpload' //파일 업로드가 있는 페이지에서 로딩
	], function($) {
		// 버튼 권한설정
		fn_proc_btn_auth('OPERATION06010');
		// 공통코드 표시
		fn_make_select(CODE_LIST, 'USE_YN', 'ITP_FORM_OPERATION06010_SEARCH_USE_YN');
		fn_make_select(CODE_LIST, 'COM_METH_CD', 'ITP_FORM_OPERATION06010_SEARCH_COM_METH_CD');
		fn_make_select(CODE_LIST, 'USE_YN', 'ITP_FORM_OPERATION06010_DETAIL_USE_YN', true, '선택');
		fn_make_select(CODE_LIST, 'COM_METH_CD', 'ITP_FORM_OPERATION06010_DETAIL_COM_METH_CD', true, '선택');
		fn_make_select(CODE_LIST, 'SR_TP_CD', 'ITP_FORM_OPERATION06010_DETAIL_SR_TP_CD', true, '선택');

		// 조회일자 지정
		var now = new Date();
		$('#ITP_TAB_OPERATION06010 .input-group.date').datepicker(ITP_DATE_LANGUAGE);
		$('#ITP_FORM_OPERATION06010_SEARCH_FROM_DT').datepicker('setDate', new Date(now.setMonth(now.getMonth() - 1)));
		$('#ITP_FORM_OPERATION06010_SEARCH_TO_DT').datepicker('setDate', new Date());

		// 그리드
		itp_fn_jqgrid_resize(OPERATION06010_GRID_ID, OPERATION06010_GRID_LIST, 'lg');
		itp_fn_OPERATION06010_grid.init();
    	itp_fn_fire_window_resize();

		// 조회
    	itp_fn_OPERATION06010_search();

		// 조회 버튼 클릭
		$('#ITP_BTN_OPERATION06010_SRH').on('click', function() {
			itp_OPERATION06010_search = true;
			let param = $('#ITP_FORM_OPERATION06010_SEARCH').serializeObject();
			param.gridSize = $.jgrid.defaults.rowNum;
			param.gridPage = $.jgrid.defaults.page;
			$(OPERATION06010_GRID_ID).setGridParam({'postData': JSON.stringify(param)}).trigger('reloadGrid');
		});

		// 수정 버튼
		$('#ITP_BTN_OPERATION06010_MODIFY').on('click', function() {
			itp_fn_form_clear_validate(null, '#ITP_FORM_OPERATION06010_DETAIL');
			const ifNoVal = $('#ITP_FORM_OPERATION06010_VIEW_IF_NO').val();
			const key = {ifNo: ifNoVal, viewCd: 'R'};
			var param = $.param(key);
			itp_fn_OPERATION06010_detail(param);
		});

		// 신규등록 버튼
		$('#ITP_BTN_OPERATION06010_NEWREG').on('click', function() {
			itp_fn_OPERATION06010_switch_screen('ADD');
			itp_fn_form_clear_validate(null, '#ITP_FORM_OPERATION06010_DETAIL');
		});

		// 취소/목록 버튼
		$('#ITP_BTN_OPERATION06010_CANCELLIST').on('click', function() {
			itp_fn_OPERATION06010_search();
    	});

		// 삭제 버튼
		$('#ITP_BTN_OPERATION06010_DELETE').on('click', function() {
			var searhFn = function() {
				ITP_FORM_OPERATION06010_DETAIL_IS_WRITING = false;
				itp_fn_OPERATION06010_search();
			};
			var deleteFn = {
				callBack: function(args) {
					const key = {'ifNo':  $('#ITP_FORM_OPERATION06010_DETAIL_IF_NO').val()};
					const param = $.param(key);
					fn_ajax_call(INTERFACE_REMOVE_INTERFACE, param, searhFn, 'GET');					
				}
			};
			itp_fn_modal_confirm(ITP_MSG_LOCALE.message.form.deleteData, deleteFn, null);
		});

		// 저장 버튼
		$('#ITP_BTN_OPERATION06010_SAVE').on('click', function() {
			const formId = '#ITP_FORM_OPERATION06010_DETAIL';
			itp_fn_form_clear_validate(null, formId);
			var vali_ifId = itp_fn_form_validate(formId, formId + '_IF_ID', ['empty'], undefined);
			var vali_useYn = itp_fn_form_validate(formId, formId + '_USE_YN', ['empty'], undefined);
			var vali_ifNm = itp_fn_form_validate(formId, formId + '_IF_NM', ['empty'], undefined);
			var vali_linkInfo = itp_fn_form_validate(formId, formId + '_LINK_INFO', ['empty'], undefined);
			var vali_comMethCd = itp_fn_form_validate(formId, formId + '_COM_METH_CD', ['empty'], undefined);
			var vali_srTpCd = itp_fn_form_validate(formId, formId + '_SR_TP_CD', ['empty'], undefined);
			var vali_ifUrl = itp_fn_form_validate(formId, formId + '_IF_URL', ['empty'], undefined);

			if (vali_ifId && vali_useYn && vali_ifNm && vali_linkInfo && vali_comMethCd && vali_srTpCd && vali_ifUrl) {
				let param = $(formId).serializeObject();
				var searhFn = function() {
					ITP_FORM_OPERATION06010_DETAIL_IS_WRITING = false;
					itp_fn_OPERATION06010_search();
				};
				fn_ajax_call(INTERFACE_SAVE_INTERFACE, JSON.stringify(param), searhFn, 'POST');
			}
		});

	});
});

var itp_fn_OPERATION06010_switch_screen = function(mode) {
	if(mode == 'LIST') { // 목록
		$('#ITP_BTN_OPERATION06010_MODIFY').hide();
		$('#ITP_BTN_OPERATION06010_CANCELLIST').hide();
		$('#ITP_BTN_OPERATION06010_DELETE').hide();
		$('#ITP_BTN_OPERATION06010_SAVE').hide();
		fn_show_btn_auth('#ITP_BTN_OPERATION06010_SRH');
		fn_show_btn_auth('#ITP_BTN_OPERATION06010_NEWREG');
		
		$('#ITP_AJAX_OPERATION06010_LIST_CONTAINER').show();
		$('#ITP_AJAX_OPERATION06010_DETAIL_CONTAINER').hide();
		$('#ITP_AJAX_OPERATION06010_VIEW_CONTAINER').hide();
	} else if(mode == 'ADD') { // 등록
		$('#ITP_BTN_OPERATION06010_SRH').hide();
		$('#ITP_BTN_OPERATION06010_MODIFY').hide();
		$('#ITP_BTN_OPERATION06010_NEWREG').hide();
		$('#ITP_BTN_OPERATION06010_DELETE').hide();
		fn_show_btn_auth('#ITP_BTN_OPERATION06010_CANCELLIST');
		fn_show_btn_auth('#ITP_BTN_OPERATION06010_SAVE');
		
		$('#ITP_AJAX_OPERATION06010_LIST_CONTAINER').hide();
		$('#ITP_AJAX_OPERATION06010_DETAIL_CONTAINER').show();
		$('#ITP_AJAX_OPERATION06010_VIEW_CONTAINER').hide();

		$('#ITP_FORM_OPERATION06010_DETAIL_VIEW_CD').val('C');
		$('#ITP_FORM_OPERATION06010_DETAIL_IF_NO').val('');
		$('#ITP_FORM_OPERATION06010_DETAIL_USE_YN').val('');
		$('#ITP_FORM_OPERATION06010_DETAIL_IF_NM').val('');
		$('#ITP_FORM_OPERATION06010_DETAIL_LINK_INFO').val('');
		$('#ITP_FORM_OPERATION06010_DETAIL_COM_METH_CD').val('');
		$('#ITP_FORM_OPERATION06010_DETAIL_SR_TP_CD').val('');
		$('#ITP_FORM_OPERATION06010_DETAIL_IF_URL').val('');
		$('#ITP_FORM_OPERATION06010_DETAIL_API_INFO').val('');
		$('#ITP_FORM_OPERATION06010_DETAIL_REQUEST_INFO').val('');
		$('#ITP_FORM_OPERATION06010_DETAIL_RESPONSE_INFO').val('');
		
	} else if(mode == 'MODIFY') { // 수정
		$('#ITP_BTN_OPERATION06010_SRH').hide();
		$('#ITP_BTN_OPERATION06010_MODIFY').hide();
		$('#ITP_BTN_OPERATION06010_NEWREG').hide();
		fn_show_btn_auth('#ITP_BTN_OPERATION06010_CANCELLIST');
		fn_show_btn_auth('#ITP_BTN_OPERATION06010_SAVE');
		fn_show_btn_auth('#ITP_BTN_OPERATION06010_DELETE');
		
		$('#ITP_AJAX_OPERATION06010_LIST_CONTAINER').hide();
		$('#ITP_AJAX_OPERATION06010_DETAIL_CONTAINER').show();
		$('#ITP_AJAX_OPERATION06010_VIEW_CONTAINER').hide();
	} else if(mode == 'VIEW') { // 보기
		$('#ITP_BTN_OPERATION06010_SRH').hide();
		$('#ITP_BTN_OPERATION06010_NEWREG').hide();
		$('#ITP_BTN_OPERATION06010_DELETE').hide();
		$('#ITP_BTN_OPERATION06010_SAVE').hide();
		fn_show_btn_auth('#ITP_BTN_OPERATION06010_MODIFY');
		fn_show_btn_auth('#ITP_BTN_OPERATION06010_CANCELLIST');
		
		$('#ITP_AJAX_OPERATION06010_LIST_CONTAINER').hide();
		$('#ITP_AJAX_OPERATION06010_DETAIL_CONTAINER').hide();
		$('#ITP_AJAX_OPERATION06010_VIEW_CONTAINER').show();
	}
};

var itp_fn_OPERATION06010_grid = {
	init: function() {
		// 데이터 없을때
		itp_fn_OPERATION06010_empty.push();
		$(OPERATION06010_GRID_EMPTY).on('click', function() {
			itp_fn_OPERATION06010_empty.back();
			itp_OPERATION06010_param.gridSize = $.jgrid.defaults.rowNum;
			$(OPERATION06010_GRID_ID).setGridParam({'postData': JSON.stringify(itp_OPERATION06010_param)}).trigger('reloadGrid');
		});
	},
	callBack: function() {
		let param = $('#ITP_FORM_OPERATION06010_SEARCH').serializeObject();
		param.gridSize = $.jgrid.defaults.rowNum;
		$(OPERATION06010_GRID_ID).jqGrid({
			colModel: [
				{
					index: 'IF_NO', name: 'ifNo',
					label: ITP_MSG_LOCALE.label.ifNo, //외부연동번호
					width: '10', fixed: false, align: 'center',
					sortable: false, hidden: true
				},
				{
					index: 'IF_ID', name: 'ifId',
					label: ITP_MSG_LOCALE.label.ifId, //외부연동아이디
					width: '10', fixed: false, align: 'center',
					sortable: false, hidden: false
				},
				{
					index: 'IF_NM', name: 'ifNm',
					label: ITP_MSG_LOCALE.label.ifNm, //외부연동명
					width: '15', fixed: false, align: 'center',
					sortable: false, hidden: false
				},
				{
					index: 'USE_YN_NM', name: 'useYnNm',
					label: ITP_MSG_LOCALE.label.useYn, //사용여부
					width: '10', fixed: false, align: 'center',
					sortable: false, hidden: false
				},
				{
					index: 'COM_METH_NM', name: 'comMethNm',
					label: ITP_MSG_LOCALE.label.comMethCd, //통신방식
					width: '6', fixed: false, align: 'center',
					sortable: false, hidden: false
				},
				{
					index: 'LINK_INFO', name: 'linkInfo',
					label: ITP_MSG_LOCALE.label.linkInfo, //연동정보
					width: '10', fixed: false, align: 'center',
					sortable: false, hidden: false
				},
				{
					index: 'SR_TP_NM', name: 'srTpNm',
					label: ITP_MSG_LOCALE.label.srTpCd, //송수신구분
					width: '10', fixed: false, align: 'center',
					sortable: false, hidden: false
				},
				{
					index: 'ADD_DT', name: 'addDt',
					label: ITP_MSG_LOCALE.label.regDt, //등록일
					width: '10', fixed: false, align: 'center',
					sortable: false, hidden: false
				}
			],
			loadBeforeSend: function(jqXHR) {
			    jqXHR.setRequestHeader('X-AUTH-TOKEN', CONN_KEY);
			},
			postData: JSON.stringify(param),
			url: DOMAIN + INTERFACE_DETAIL_GRID_LIST,
			pager: OPERATION06010_GRID_PAGER,
			multiselect: false,
			rownumbers: true,
			onCellSelect: function(rowId, cellIdx, cellValue) {
				var cm = $(this).jqGrid('getGridParam', 'colModel');
				var colNm = cm[cellIdx].name;
				if (colNm == 'ifNm') {
					const ifNoVal = $(this).jqGrid('getCell', rowId, 'ifNo');
					const key = {ifNo: ifNoVal, viewCd: 'R'};
					var param = $.param(key);
					itp_fn_OPERATION06010_view(param);
				}
		   	},
			loadComplete: function(data) {
				//console.log(JSON.stringify(data));
				itp_fn_grid_load_complete(data, OPERATION06010_GRID_ID, true, 'number', 'OPERATION06010', itp_OPERATION06010_search, itp_fn_OPERATION06010_empty, true, data.gridRecords, true);
				var ids = $(OPERATION06010_GRID_ID).getDataIDs();
				$.each(ids, function(idx, rowId) {
					$(OPERATION06010_GRID_ID).jqGrid('setCell', rowId, 'ifNm', '', ITP_GRID_COL_STYLE.link);
				});
		    },
		    loadError: function(jqXHR, textStatus, errorThrown) {
		    	itp_fn_grid_load_error(jqXHR, textStatus, errorThrown);
		    },
		    onPaging: function(action) {
		    	itp_fn_grid_paging(OPERATION06010_GRID_ID, action, param);
		    }
		}).navGrid(OPERATION06010_GRID_PAGER, ITP_GRID_NAV_DEFAULTS.navGrid);
	},
	clearData : function() {
		$(OPERATION06010_GRID_ID).jqGrid('clearGridData', true);
		$(OPERATION06010_GRID_LIST).find('.ui-jqgrid-bdiv').css('min-height', '100px');
		$(OPERATION06010_GRID_EMPTY).html(ITP_MSG_LOCALE.message.grid.noData);
		$(OPERATION06010_GRID_EMPTY).show();
	},
	unload : function() {
		$.jgrid.gridUnload(OPERATION06010_GRID_ID);
	}
};

var itp_fn_OPERATION06010_search = function() {
	itp_fn_OPERATION06010_switch_screen('LIST');
	itp_fn_OPERATION06010_grid.unload();
	itp_fn_OPERATION06010_grid.callBack();
};

let itp_OPERATION06010_param = {};
let itp_OPERATION06010_search = false;
var itp_fn_OPERATION06010_empty = {
	push: function() {
		let param = $('#ITP_FORM_OPERATION06010_SEARCH').serializeObject();
		itp_OPERATION06010_param = param;
	},
	back: function() {
		$('#ITP_FORM_OPERATION06010_DEVI_TP_CD').val(itp_OPERATION06010_param.deviTpCd);
		$('#ITP_FORM_OPERATION06010_ORDER_YN').val(itp_OPERATION06010_param.orderYn);
		$('#ITP_FORM_OPERATION06010_ADT_AUTH_CD').val(itp_OPERATION06010_param.adtAuthCd);
		$('#ITP_FORM_OPERATION06010_EMAIL_RCV_YN').val(itp_OPERATION06010_param.emailRcvYn);
		$('#ITP_FORM_OPERATION06010_SMS_RCV_YN').val(itp_OPERATION06010_param.smsRcvYn);
		$('#ITP_FORM_OPERATION06010_MEMB_EXIT_DT').val(itp_OPERATION06010_param.membExitDt);
		$('#ITP_FORM_OPERATION06010_FROM_DT').val(itp_OPERATION06010_param.fromDt);
		$('#ITP_FORM_OPERATION06010_TO_DT').val(itp_OPERATION06010_param.toDt);
		$('#ITP_FORM_OPERATION06010_KEYWORD').val(itp_OPERATION06010_param.keyword);
	}
};

var itp_fn_OPERATION06010_view = function(param) {
	fn_ajax_call(INTERFACE_INFO_INTERFACE, param, itp_fn_OPERATION06010_view_callback, 'GET');
};

var itp_fn_OPERATION06010_view_callback = function(result) {
	itp_fn_OPERATION06010_switch_screen('VIEW');
	$('#ITP_FORM_OPERATION06010_VIEW #ITP_FORM_OPERATION06010_VIEW_IF_NO').val(result.ifNo);
	$('#ITP_FORM_OPERATION06010_VIEW .fnIfId').text(result.ifId);
	$('#ITP_FORM_OPERATION06010_VIEW .fnUseYn').text(result.useYnNm);
	$('#ITP_FORM_OPERATION06010_VIEW .fnIfNm').text(result.ifNm);
	$('#ITP_FORM_OPERATION06010_VIEW .fnLinkInfo').text(result.linkInfo);
	$('#ITP_FORM_OPERATION06010_VIEW .fnComMethCd').text(result.comMethNm);
	$('#ITP_FORM_OPERATION06010_VIEW .fnSrTpCd').text(result.srTpNm);
	$('#ITP_FORM_OPERATION06010_VIEW .fnIfUrl').text(result.ifUrl);
	$('#ITP_FORM_OPERATION06010_VIEW .fnApiInfo').html(result.apiInfo.replace(/(\n|\r\n)/g, '<br>'));
	$('#ITP_FORM_OPERATION06010_VIEW .fnRequestInfo').html(result.requestInfo.replace(/(\n|\r\n)/g, '<br>'));
	$('#ITP_FORM_OPERATION06010_VIEW .fnResponseInfo').html(result.responseInfo.replace(/(\n|\r\n)/g, '<br>'));
	$('#ITP_FORM_OPERATION06010_VIEW .fnAddNm').text(result.addNm);
	$('#ITP_FORM_OPERATION06010_VIEW .fnAddDt').text(result.addDt);
};


var itp_fn_OPERATION06010_detail = function(param) {
	fn_ajax_call(INTERFACE_INFO_INTERFACE, param, itp_fn_OPERATION06010_detail_callback, 'GET');
};

var itp_fn_OPERATION06010_detail_callback = function(result) {
	itp_fn_OPERATION06010_switch_screen('MODIFY');
	
	$('#ITP_FORM_OPERATION06010_DETAIL #ITP_FORM_OPERATION06010_DETAIL_VIEW_CD').val('U');
	$('#ITP_FORM_OPERATION06010_DETAIL #ITP_FORM_OPERATION06010_DETAIL_IF_NO').val(result.ifNo);
	$('#ITP_FORM_OPERATION06010_DETAIL #ITP_FORM_OPERATION06010_DETAIL_IF_ID').val(result.ifId);
	$('#ITP_FORM_OPERATION06010_DETAIL #ITP_FORM_OPERATION06010_DETAIL_USE_YN').val(result.useYn);
	$('#ITP_FORM_OPERATION06010_DETAIL #ITP_FORM_OPERATION06010_DETAIL_IF_NM').val(result.ifNm);
	$('#ITP_FORM_OPERATION06010_DETAIL #ITP_FORM_OPERATION06010_DETAIL_LINK_INFO').val(result.linkInfo);
	$('#ITP_FORM_OPERATION06010_DETAIL #ITP_FORM_OPERATION06010_DETAIL_COM_METH_CD').val(result.comMethCd);
	$('#ITP_FORM_OPERATION06010_DETAIL #ITP_FORM_OPERATION06010_DETAIL_SR_TP_CD').val(result.srTpCd);
	$('#ITP_FORM_OPERATION06010_DETAIL #ITP_FORM_OPERATION06010_DETAIL_IF_URL').val(result.ifUrl);
	$('#ITP_FORM_OPERATION06010_DETAIL #ITP_FORM_OPERATION06010_DETAIL_API_INFO').val(result.apiInfo);
	$('#ITP_FORM_OPERATION06010_DETAIL #ITP_FORM_OPERATION06010_DETAIL_REQUEST_INFO').val(result.requestInfo);
	$('#ITP_FORM_OPERATION06010_DETAIL #ITP_FORM_OPERATION06010_DETAIL_RESPONSE_INFO').val(result.responseInfo);
	$('#ITP_FORM_OPERATION06010_DETAIL .fnAddNm').text(result.addNm);
	$('#ITP_FORM_OPERATION06010_DETAIL .fnAddDt').text(result.addDt);
	
};
